/* c4.c */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<arpa/inet.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/socket.h>

#define BUFSIZE 30

void error_handling(char *message);

int main(int argc, char **argv)
{
	int sd;

	FILE * stream_one;
	FILE * stream_two;

	FILE * write_file;
	
	char buf[BUFSIZE];
	
	struct sockaddr_in serv_addr;

	if(argc!=3)
	{
		printf("Usage : %s <IP> <port> \n", argv[0]);
		exit(1);
	}

	// ù°     
	sd = socket(PF_INET, SOCK_STREAM, 0);
	if(sd == -1)
		error_handling("socket() error");

	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family=AF_INET;
	serv_addr.sin_addr.s_addr=inet_addr(argv[1]);
	serv_addr.sin_port=htons(atoi(argv[2]));

	if(connect(sd, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) == -1)
		error_handling("connect() error!");

	// ù° Է Ʈ 
	stream_one = fdopen(sd, "r");
	
	// ũƮ    Ʈ 
	stream_two = fdopen(sd, "wb");

	
	/*  ͸    */
	write_file = fopen("temp1.vox", "wb");
	if(write_file == NULL)
		error_handling("File open error");

	// ͸ ޾Ƽ Ͽ .
	
	while(1)
	{
		if(fgets(buf, sizeof(buf), stream_one) == NULL) break;
		fputs(buf, write_file);
		fflush(write_file);
	}
	
	fputs("client : get_file completed\n", stream_two);
	fflush(stream_two);

	
	fclose(stream_one);
	fclose(stream_two);
	close(sd);
	return 0;
}

void error_handling(char *message)
{
  	fputs(message, stderr);
	fputc('\n', stderr);  
	exit(1);
}
